package com.xinelu.manage.mapper.goodsCategory;

import com.xinelu.manage.domain.goodsCategory.GoodsCategory;
import com.xinelu.manage.vo.goodsCategory.ParentCategory;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 商品分类信息Mapper接口
 *
 * @author xinyilu
 * @date 2022-10-17
 */
public interface GoodsCategoryMapper {
    /**
     * 查询商品分类信息
     *
     * @param id 商品分类信息主键
     * @return 商品分类信息
     */
    GoodsCategory selectGoodsCategoryById(Long id);

    /**
     * 查询商品分类信息列表
     *
     * @param goodsCategory 商品分类信息
     * @return 商品分类信息集合
     */
    List<GoodsCategory> selectGoodsCategoryList(GoodsCategory goodsCategory);

    /**
     * 新增商品分类信息
     *
     * @param goodsCategory 商品分类信息
     * @return 结果
     */
    int insertGoodsCategory(GoodsCategory goodsCategory);

    /**
     * 修改商品分类信息
     *
     * @param goodsCategory 商品分类信息
     * @return 结果
     */
    int updateGoodsCategory(GoodsCategory goodsCategory);

    /**
     * 删除商品分类信息
     *
     * @param id 商品分类信息主键
     * @return 结果
     */
    int deleteGoodsCategoryById(Long id);

    /**
     * 批量删除商品分类信息
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    int deleteGoodsCategoryByIds(Long[] ids);

    /**
     * 查询商品分类图片
     *
     * @param ids 商品分类id
     * @return 集合
     */
    List<String> selectCategoryPictureByIds(Long[] ids);

    /**
     * 根据id查询本级及下级信息
     *
     * @param ids 主键id集合
     * @return List
     */
    List<GoodsCategory> selectCategoryByIds(Long[] ids);

    /**
     * 根据id查询本级及上级信息
     *
     * @param id 主键
     * @return ParentCategory
     */
    ParentCategory selectParentIdById(Long id);

    /**
     * 根据商品分类名称查询名称数量
     *
     * @param goodsCategoryName 商品分类名称
     * @param id                主键id
     * @return int
     */
    int getGoodsCategoryNameCount(@Param("id") Long id, @Param("goodsCategoryName") String goodsCategoryName);
}
